<script lang="ts">
	import { createEventDispatcher } from 'svelte';

	const dispatch = createEventDispatcher();
	export let period = 1000;
	export let play: () => void;
	export let step: () => void;
	export let stop: () => void;
	export let reset: () => void;
	export const minPeriod = 100;
	export const maxPeriod = 5000;

	let isPlaying = false;

	let onUpdate = (e: Event) => {
		// update the period
		period = parseInt(e === null ? 0 : (e as Event).target.value);
		dispatch('periodUpdate', period);
	};
</script>

<button
	on:click={() => {
		console.log('Play');
		if (!isPlaying && period >= minPeriod) {
			isPlaying = true;
			play();
		}
	}}>Play</button
>
<button
	on:click={() => {
		console.log('Step');
		isPlaying = false;
		step();
	}}>Step</button
>
<button
	on:click={() => {
		console.log('Stop');
		isPlaying = false;
		stop();
	}}>Stop</button
>
<button
	on:click={() => {
		console.log('Reset');
		isPlaying = false;
		reset();
	}}>Reset</button
>

<label for="period">Period(ms)</label>
<input
	type="number"
	id="period_select"
	name="period"
	min={minPeriod}
	max={maxPeriod}
	value={period}
	on:change={onUpdate}
/>

<style>
</style>
